// Author : Quentin BENETHUILLERE
// Date of creation : 2021/03/22
// Last modification : 2021/03/22

// ------------------
// CLOCK
// ------------------
#define F_CPU 8000000

// ------------------
// LIBRARIES
// ------------------
#include <avr/io.h>
#include <util/delay.h>

// ------------------
// DEFINE
// ------------------
#define PIN_MOSFET 3
#define PIN_BUTTON 4

/*
ATTiny45
*/
// Button = PB4 = INPUT. 0 when button is pushed, 1 when button is released.
// MOSFEFT gate = PB3 = OUTPUT.

int main(void)
{
	DDRB = 0b11101111; // Defining input/output pins (0=input)
	PORTB = PORTB & ~(1<<PIN_MOSFET); // MOSFET base = 0
	
	while(1)
		{
		
	  	if ((PINB & (1<<PIN_BUTTON)) == 0) // Button pushed.
	  	{
				PORTB = PORTB | (1<<PIN_MOSFET) ; // MOSFET base = 1
			}
		else
		{
			PORTB = PORTB & ~(1<<PIN_MOSFET); // MOSFET base = 0
		}
	}
	return 0; // To avoid warning messages from the compiler (although the program will never reach this line in reality)
}
