// Author : Quentin BENETHUILLERE
// Date of creation : 2021/03/22
// Last modification : 2021/03/22

/*
 * This program aims at activating a function (LED ON or lock mechanism open) as long as a push button is pressed on a customized version of an hello world board.
 */

// -------------------------
// DECLARATION OF DEFINES 
// -------------------------

#define PIN_BUTTON 4 // Input pin connected to the push button.
#define PIN_MOSFET 3 // Output pin connected to the MOSFET gate.

// -------------------------
// DECLARATION OF VARIABLES 
// -------------------------

// ------------------------------------------------
// Adjustable variables (program main parameters)
// ------------------------------------------------

// ------------------------------------------------
// PIN connections
// ------------------------------------------------

// ------------------------------------------------
// Other variables
// ------------------------------------------------
char button_state = 1; // Button not pushed

// -------------------------
// INITIALIZATION 
// -------------------------

// Setup code. Run once at power up, or each time the RESET button is pressed:
void setup() {

// ------------------------------------------------
// Input / Output
// ------------------------------------------------

  pinMode(PIN_BUTTON, INPUT);   // pin connected to the push button = input.  
  pinMode(PIN_MOSFET, OUTPUT);   // pin connected to the MOSFET gate = output.

// ------------------------------------------------
// PIN initial states
// ------------------------------------------------
  digitalWrite(PIN_BUTTON, HIGH); // HIGH state = button not pushed.
  digitalWrite(PIN_MOSFET, LOW);

} // end of setup() function

// -------------------------
// MAIN
// -------------------------

// Loop function that runs repeatedly:
void loop() {
  button_state = digitalRead(PIN_BUTTON);
  if (button_state==0){ // button pushed
    digitalWrite(PIN_MOSFET, HIGH);    // turn the LED off by making the voltage LOW
  }
  else{ // button NOT pushed
    digitalWrite(PIN_MOSFET, LOW);    // turn the LED off by making the voltage LOW
  }

} // end of loop() function
